Package ghidra.app.util.bin.format.macho.commands

# Class LoadCommandTypes

java.lang.Object
ghidra.app.util.bin.format.macho.commands.LoadCommandTypes

public final class LoadCommandTypes extends Object
`LoadCommand` types

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `LC_BUILD_VERSION`
  Build for platform min OS version
  `static final int`
  `LC_CODE_SIGNATURE`
  local of code signature
  `static final int`
  `LC_DATA_IN_CODE`
  Table of non-instructions in __text
  `static final int`
  `LC_DYLD_CHAINED_FIXUPS`
  Used with linkedit_data_command
  `static final int`
  `LC_DYLD_ENVIRONMENT`
  String for DYLD to treat environment variable
  `static final int`
  `LC_DYLD_EXPORTS_TRIE`
  Used with linkedit_data_command, payload is trie
  `static final int`
  `LC_DYLD_INFO`
  compressed dyld information
  `static final int`
  `LC_DYLD_INFO_ONLY`
  compressed dyld information only
  `static final int`
  `LC_DYLIB_CODE_SIGN_DRS`
  Code signing DRs copied from linked dylibs
  `static final int`
  `LC_DYSYMTAB`
  dynamic link-edit symbol table info
  `static final int`
  `LC_ENCRYPTION_INFO`
  encrypted segment information
  `static final int`
  `LC_ENCRYPTION_INFO_64`
  64-bit encrypted segment information
  `static final int`
  `LC_FILESET_ENTRY`
  Used with fileset_entry_command
  `static final int`
  `LC_FUNCTION_STARTS`
  Compressed table of function start addresses
  `static final int`
  `LC_FVMFILE`
  fixed VM file inclusion (internal use)
  `static final int`
  `LC_ID_DYLIB`
  dynamically linked shared lib ident
  `static final int`
  `LC_ID_DYLINKER`
  dynamic linker identification
  `static final int`
  `LC_IDENT`
  object identification info (obsolete)
  `static final int`
  `LC_IDFVMLIB`
  fixed VM shared library identification
  `static final int`
  `LC_LAZY_LOAD_DYLIB`
  Delay load of dylib until first use
  `static final int`
  `LC_LINKER_OPTIONS`
  Linker options in MH_OBJECT files
  `static final int`
  `LC_LOAD_DYLIB`
  load a dynamically linked shared library
  `static final int`
  `LC_LOAD_DYLINKER`
  load a dynamic linker
  `static final int`
  `LC_LOAD_UPWARD_DYLIB`
  Load upward dylib
  `static final int`
  `LC_LOAD_WEAK_DYLIB`
  load a dynamically linked shared library that is allowed to be missing (all symbols are weak imported)
  `static final int`
  `LC_LOADFVMLIB`
  load a specified fixed VM shared library
  `static final int`
  `LC_MAIN`
  Replacement for LC_UNIXTHREAD
  `static final int`
  `LC_NOTE`
  Arbitrary data included within a Mach-O file
  `static final int`
  `LC_OPTIMIZATION_HINT`
  Optimization hints in MH_OBJECT files
  `static final int`
  `LC_PREBIND_CKSUM`
  prebind checksum
  `static final int`
  `LC_PREBOUND_DYLIB`
  modules prebound for a dynamically linked shared library
  `static final int`
  `LC_PREPAGE`
  prepage command (internal use)
  `static final int`
  `LC_REEXPORT_DYLIB`
  load and re-export dylib
  `static final int`
  `LC_REQ_DYLD`
  After MacOS X 10.1 when a new load command is added that is required to be understood by the dynamic linker for the image to execute properly the LC_REQ_DYLD bit will be or'ed into the load command constant.
  `static final int`
  `LC_ROUTINES`
  image routines
  `static final int`
  `LC_ROUTINES_64`
  64-bit image routines
  `static final int`
  `LC_RPATH`
  Run path additions
  `static final int`
  `LC_SEGMENT`
  segment of this file to be mapped
  `static final int`
  `LC_SEGMENT_64`
  64-bit segment of this file to be mapped
  `static final int`
  `LC_SEGMENT_SPLIT_INFO`
  local of info to split segments
  `static final int`
  `LC_SOURCE_VERSION`
  Source version used to build binary
  `static final int`
  `LC_SUB_CLIENT`
  sub client
  `static final int`
  `LC_SUB_FRAMEWORK`
  sub framework
  `static final int`
  `LC_SUB_LIBRARY`
  sub library
  `static final int`
  `LC_SUB_UMBRELLA`
  sub umbrella
  `static final int`
  `LC_SYMSEG`
  link-edit gdb symbol table info (obsolete)
  `static final int`
  `LC_SYMTAB`
  link-edit stab symbol table info
  `static final int`
  `LC_THREAD`
  thread
  `static final int`
  `LC_TWOLEVEL_HINTS`
  two-level namespace lookup hints
  `static final int`
  `LC_UNIXTHREAD`
  unix thread (includes a stack)
  `static final int`
  `LC_UUID`
  specifies the 128 bit UUID for an image
  `static final int`
  `LC_VERSION_MIN_IPHONEOS`
  Build for iPhoneOS min OS version
  `static final int`
  `LC_VERSION_MIN_MACOSX`
  Build for MacOSX min OS version
  `static final int`
  `LC_VERSION_MIN_TVOS`
  Build for AppleTV min OS version
  `static final int`
  `LC_VERSION_MIN_WATCHOS`
  Build for Watch min OS version

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LoadCommandTypes()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static final String`
  `getLoadCommandName(int type)`
  Gets the name of the given load command type

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### LC_REQ_DYLD

    public static final int LC_REQ_DYLD
    After MacOS X 10.1 when a new load command is added that is required to be understood by the dynamic linker for the image to execute properly the LC_REQ_DYLD bit will be or'ed into the load command constant. If the dynamic linker sees such a load command that it does not understand, it will issue a "unknown load command required for execution" error and refuse to use the image. Other load commands without this bit that are not understood will simply be ignored.
    See Also:
      - Constant Field Values

  - ### LC_SEGMENT

    public static final int LC_SEGMENT
    segment of this file to be mapped
    See Also:
      - Constant Field Values

  - ### LC_SYMTAB

    public static final int LC_SYMTAB
    link-edit stab symbol table info
    See Also:
      - Constant Field Values

  - ### LC_SYMSEG

    public static final int LC_SYMSEG
    link-edit gdb symbol table info (obsolete)
    See Also:
      - Constant Field Values

  - ### LC_THREAD

    public static final int LC_THREAD
    thread
    See Also:
      - Constant Field Values

  - ### LC_UNIXTHREAD

    public static final int LC_UNIXTHREAD
    unix thread (includes a stack)
    See Also:
      - Constant Field Values

  - ### LC_LOADFVMLIB

    public static final int LC_LOADFVMLIB
    load a specified fixed VM shared library
    See Also:
      - Constant Field Values

  - ### LC_IDFVMLIB

    public static final int LC_IDFVMLIB
    fixed VM shared library identification
    See Also:
      - Constant Field Values

  - ### LC_IDENT

    public static final int LC_IDENT
    object identification info (obsolete)
    See Also:
      - Constant Field Values

  - ### LC_FVMFILE

    public static final int LC_FVMFILE
    fixed VM file inclusion (internal use)
    See Also:
      - Constant Field Values

  - ### LC_PREPAGE

    public static final int LC_PREPAGE
    prepage command (internal use)
    See Also:
      - Constant Field Values

  - ### LC_DYSYMTAB

    public static final int LC_DYSYMTAB
    dynamic link-edit symbol table info
    See Also:
      - Constant Field Values

  - ### LC_LOAD_DYLIB

    public static final int LC_LOAD_DYLIB
    load a dynamically linked shared library
    See Also:
      - Constant Field Values

  - ### LC_ID_DYLIB

    public static final int LC_ID_DYLIB
    dynamically linked shared lib ident
    See Also:
      - Constant Field Values

  - ### LC_LOAD_DYLINKER

    public static final int LC_LOAD_DYLINKER
    load a dynamic linker
    See Also:
      - Constant Field Values

  - ### LC_ID_DYLINKER

    public static final int LC_ID_DYLINKER
    dynamic linker identification
    See Also:
      - Constant Field Values

  - ### LC_PREBOUND_DYLIB

    public static final int LC_PREBOUND_DYLIB
    modules prebound for a dynamically linked shared library
    See Also:
      - Constant Field Values

  - ### LC_ROUTINES

    public static final int LC_ROUTINES
    image routines
    See Also:
      - Constant Field Values

  - ### LC_SUB_FRAMEWORK

    public static final int LC_SUB_FRAMEWORK
    sub framework
    See Also:
      - Constant Field Values

  - ### LC_SUB_UMBRELLA

    public static final int LC_SUB_UMBRELLA
    sub umbrella
    See Also:
      - Constant Field Values

  - ### LC_SUB_CLIENT

    public static final int LC_SUB_CLIENT
    sub client
    See Also:
      - Constant Field Values

  - ### LC_SUB_LIBRARY

    public static final int LC_SUB_LIBRARY
    sub library
    See Also:
      - Constant Field Values

  - ### LC_TWOLEVEL_HINTS

    public static final int LC_TWOLEVEL_HINTS
    two-level namespace lookup hints
    See Also:
      - Constant Field Values

  - ### LC_PREBIND_CKSUM

    public static final int LC_PREBIND_CKSUM
    prebind checksum
    See Also:
      - Constant Field Values

  - ### LC_LOAD_WEAK_DYLIB

    public static final int LC_LOAD_WEAK_DYLIB
    load a dynamically linked shared library that is allowed to be missing (all symbols are weak imported)
    See Also:
      - Constant Field Values

  - ### LC_SEGMENT_64

    public static final int LC_SEGMENT_64
    64-bit segment of this file to be mapped
    See Also:
      - Constant Field Values

  - ### LC_ROUTINES_64

    public static final int LC_ROUTINES_64
    64-bit image routines
    See Also:
      - Constant Field Values

  - ### LC_UUID

    public static final int LC_UUID
    specifies the 128 bit UUID for an image
    See Also:
      - Constant Field Values

  - ### LC_RPATH

    public static final int LC_RPATH
    Run path additions
    See Also:
      - Constant Field Values

  - ### LC_CODE_SIGNATURE

    public static final int LC_CODE_SIGNATURE
    local of code signature
    See Also:
      - Constant Field Values

  - ### LC_SEGMENT_SPLIT_INFO

    public static final int LC_SEGMENT_SPLIT_INFO
    local of info to split segments
    See Also:
      - Constant Field Values

  - ### LC_REEXPORT_DYLIB

    public static final int LC_REEXPORT_DYLIB
    load and re-export dylib
    See Also:
      - Constant Field Values

  - ### LC_LAZY_LOAD_DYLIB

    public static final int LC_LAZY_LOAD_DYLIB
    Delay load of dylib until first use
    See Also:
      - Constant Field Values

  - ### LC_ENCRYPTION_INFO

    public static final int LC_ENCRYPTION_INFO
    encrypted segment information
    See Also:
      - Constant Field Values

  - ### LC_DYLD_INFO

    public static final int LC_DYLD_INFO
    compressed dyld information
    See Also:
      - Constant Field Values

  - ### LC_DYLD_INFO_ONLY

    public static final int LC_DYLD_INFO_ONLY
    compressed dyld information only
    See Also:
      - Constant Field Values

  - ### LC_LOAD_UPWARD_DYLIB

    public static final int LC_LOAD_UPWARD_DYLIB
    Load upward dylib
    See Also:
      - Constant Field Values

  - ### LC_VERSION_MIN_MACOSX

    public static final int LC_VERSION_MIN_MACOSX
    Build for MacOSX min OS version
    See Also:
      - Constant Field Values

  - ### LC_VERSION_MIN_IPHONEOS

    public static final int LC_VERSION_MIN_IPHONEOS
    Build for iPhoneOS min OS version
    See Also:
      - Constant Field Values

  - ### LC_FUNCTION_STARTS

    public static final int LC_FUNCTION_STARTS
    Compressed table of function start addresses
    See Also:
      - Constant Field Values

  - ### LC_DYLD_ENVIRONMENT

    public static final int LC_DYLD_ENVIRONMENT
    String for DYLD to treat environment variable
    See Also:
      - Constant Field Values

  - ### LC_MAIN

    public static final int LC_MAIN
    Replacement for LC_UNIXTHREAD
    See Also:
      - Constant Field Values

  - ### LC_DATA_IN_CODE

    public static final int LC_DATA_IN_CODE
    Table of non-instructions in __text
    See Also:
      - Constant Field Values

  - ### LC_SOURCE_VERSION

    public static final int LC_SOURCE_VERSION
    Source version used to build binary
    See Also:
      - Constant Field Values

  - ### LC_DYLIB_CODE_SIGN_DRS

    public static final int LC_DYLIB_CODE_SIGN_DRS
    Code signing DRs copied from linked dylibs
    See Also:
      - Constant Field Values

  - ### LC_ENCRYPTION_INFO_64

    public static final int LC_ENCRYPTION_INFO_64
    64-bit encrypted segment information
    See Also:
      - Constant Field Values

  - ### LC_LINKER_OPTIONS

    public static final int LC_LINKER_OPTIONS
    Linker options in MH_OBJECT files
    See Also:
      - Constant Field Values

  - ### LC_OPTIMIZATION_HINT

    public static final int LC_OPTIMIZATION_HINT
    Optimization hints in MH_OBJECT files
    See Also:
      - Constant Field Values

  - ### LC_VERSION_MIN_TVOS

    public static final int LC_VERSION_MIN_TVOS
    Build for AppleTV min OS version
    See Also:
      - Constant Field Values

  - ### LC_VERSION_MIN_WATCHOS

    public static final int LC_VERSION_MIN_WATCHOS
    Build for Watch min OS version
    See Also:
      - Constant Field Values

  - ### LC_NOTE

    public static final int LC_NOTE
    Arbitrary data included within a Mach-O file
    See Also:
      - Constant Field Values

  - ### LC_BUILD_VERSION

    public static final int LC_BUILD_VERSION
    Build for platform min OS version
    See Also:
      - Constant Field Values

  - ### LC_DYLD_EXPORTS_TRIE

    public static final int LC_DYLD_EXPORTS_TRIE
    Used with linkedit_data_command, payload is trie
    See Also:
      - Constant Field Values

  - ### LC_DYLD_CHAINED_FIXUPS

    public static final int LC_DYLD_CHAINED_FIXUPS
    Used with linkedit_data_command
    See Also:
      - Constant Field Values

  - ### LC_FILESET_ENTRY

    public static final int LC_FILESET_ENTRY
    Used with fileset_entry_command
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### LoadCommandTypes

    public LoadCommandTypes()

- ## Method Details

  - ### getLoadCommandName

    public static final String getLoadCommandName(int type)
    Gets the name of the given load command type
    Parameters:
      `type` - The load command type
    Returns:
      The name of the given load command type